# 🤖 Bot Mirza Panel

A Powerful Bot for Selling VPN Services with Auto Configuration Build.

<p align="center">
    <a href="https://t.me/mirzapanel" target="_blank">
        <img src="https://img.shields.io/badge/Telegram-Group-blue?style=flat-square&logo=telegram" alt="Telegram Group"/>
    </a>
    <a href="https://github.com/mahdiMGF2/botmirzapanel" target="_blank">
        <img src="https://img.shields.io/github/stars/mahdiMGF2/botmirzapanel?style=social" alt="GitHub Stars"/>
    </a>
    <a href="https://img.shields.io/github/forks/mahdiMGF2/botmirzapanel?style=flat-square" target="_blank">
        <img src="https://img.shields.io/github/forks/mahdiMGF2/botmirzapanel?style=flat-square" alt="GitHub Forks"/>
    </a>
    <a href="https://github.com/mahdiMGF2/botmirzapanel/issues" target="_blank">
        <img src="https://img.shields.io/github/issues/mahdiMGF2/botmirzapanel?style=flat-square" alt="GitHub Issues"/>
    </a>
</p>


---

## 📚 Table of Contents

- [✨ Overview](#-overview)
- [⚙️ Features](#️-features)
- [🚀 Installation](#-installation)
  - [Beta Installation](#️-beta-installation)
  - [Updating the Bot](#-updating-bot)
  - [Removing the Bot](#-removing)
- [📱 Demo Bot](#-demo-bot)
- [💵 Financial Support](#-financial-support)

---

## ✨ Overview

**Mirza Bot Panel** is a feature-rich Telegram bot designed for selling VPN services for platforms like **Marzban** and **3x-ui panels**. This bot simplifies the process of VPN subscription sales, enabling seamless automation, configuration building, and user management.

Mirza Panel comes in two versions:  
1. **Free Version** 🆓: Offers basic functionalities to get started with VPN sales.  
2. **Subscription Version** 💎: Provides advanced features for businesses looking for more customization, detailed analytics, and enhanced management options.  

Whether you’re offering trial accounts or managing large-scale VPN services, this bot covers everything you need to run a successful VPN business.

---

## ⚙️ Features

### 🔹 **Free Version Features**

- ✅ VPN Purchase with Auto Configuration Creation
- ✅ View Purchased Services
- ✅ Trial Accounts for Users
- ✅ User Support Section
- ✅ Verification via Phone Number
- ✅ Payments via:
  - Card-to-Card
  - **NowPayments Gateway**
  - **aqayepardakht Gateway**
- ✅ Fully Automated Configuration Creation
- ✅ Compatibility with All Protocols
- ✅ Mandatory Channel Membership for Purchases
- ✅ Detailed Purchase and Trial Account Reports
- ✅ Tutorial Section with Admin-Customizable Content
- ✅ Balance Management via Admin Panel
- ✅ Multiple Admin Support
- ✅ Manage Purchased Services:
  - Renewals
  - Additional Volume Purchases
  - Configuration Retrieval
  - Updating Service Links
- ✅ FAQ Section
- ✅ Text Customization from the Bot
- ✅ Product and Panel Management
- ✅ Admin-Specified Username Generation Methods
- ✅ Configuration Settings Based on Protocols
- ✅ Gateway Management

---

### 🔹 **Subscription Version Features**

In addition to the features of the Free Version, the Subscription Version includes:

- 🔐 Admin Access Levels (Management, Sales, Support)
- 🧾 View and Manage All Users in the Bot
- 🎟️ Advanced Discount Code Management
- 🤝 Reseller Support
- 💰 Refund and Service Removal Options
- ⚡ Advanced Panel-Specific Bandwidth Management
- 🔄 Manage Panel Status
- 🔑 Separate Panels for Test Accounts
- ⏳ Set Service Purchase Durations
- 📤 Send Configurations Directly After Payment
- 🔄 Renewal and Volume Purchases (Even for Non-Existing Services)
- 💳 Inventory Control (Set Minimum and Maximum Inventory Increases)
- 📩 Support Messages with Admin Responses
- 🔗 Advanced Subset Management
- 🛒 Bulk Purchase Options
- 🆔 Multiple Username Creation Methods
- 🔍 Quick Service Search
- 📅 Advanced Cron Job Settings
- 📊 Comprehensive Bot Statistics
- ❌ Limit Configuration Creation per Panel
- 🖥️ Web Panel Integration
- 🌍 Change Location of Services
- 🔄 Transfer Services Between Users
- 💱 Rial Exchange Payment Gateways

📌 **Subscription Purchase Guide**: [View Guide](https://t.me/mirzaperimium/4)

---

## 🚀 Installation

### Prerequisites

Ensure you have the following before installation:
- 🖥️ **Ubuntu Server 22**
- 🌐 **A Domain Name**

### 🔧 Installing the Bot (Stable Version)

Run the following command in your server terminal:

```bash
curl -o install.sh -L https://raw.githubusercontent.com/mahdiMGF2/botmirzapanel/main/install.sh && bash install.sh
```

When prompted, **select option 1** to complete the installation.

---

### ⚠️ Beta Installation

💡 *Disclaimer*: This is a beta release. It may contain bugs or issues. Use it with caution and report any problems you encounter.

To install the beta version, run:

```bash
curl -o install.sh -L https://raw.githubusercontent.com/mahdiMGF2/botmirzapanel/main/install.sh && bash install.sh -beta
```

---

## 🔄 updating bot

To update your bot to the latest version, use the following command:

```bash
curl -o install.sh -L https://raw.githubusercontent.com/mahdiMGF2/botmirzapanel/main/install.sh && bash install.sh -update
```

---

## ❌ removing

If you want to completely remove the bot from your server, run the following command:

```bash
curl -o install.sh -L https://raw.githubusercontent.com/mahdiMGF2/botmirzapanel/main/install.sh && bash install.sh
```

When prompted, **select option 3** to remove the bot.

---

## 📱 Demo Bot

Want to see Mirza Panel in action? Try the demo bot here:  
👉 [Demo Bot](https://t.me/marzbaninfobot)

---

## 💵 Financial Support

If you find **Mirza Panel** helpful and would like to support its development, you can make a financial contribution via cryptocurrency.

- **TRX Network (TRC20)**:  
  `TNvwhpNtXxKMFFeVzGR8GNZ6gL4aECituU`

Your support ensures continued updates and improvements for this project. Thank you! 🙌

### Contributors

![Contributors](https://contrib.rocks/image?repo=mahdiMGF2/botmirzapanel)
